| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImplicitSum Class Reference

implicit sum of other implicit functions More...

`#include <vtkImplicitSum.h>`

Inheritance diagram for vtkImplicitSum:
[legend]
Collaboration diagram for vtkImplicitSum:
[legend]

## Public Types
typedef vtkImplicitFunction | Superclass
Public Types inherited from vtkImplicitFunction
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkImplicitSum * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
double | EvaluateFunction (double x[3]) override
| Evaluate function at position x-y-z and return value. More...
void | EvaluateGradient (double x[3], double g[3]) override
| Evaluate gradient of the weighted sum of functions. More...
vtkMTimeType | GetMTime () override
| Override modified time retrieval because of object dependencies. More...
void | AddFunction (vtkImplicitFunction *in, double weight)
| Add another implicit function to the list of functions, along with a weighting factor. More...
void | AddFunction (vtkImplicitFunction *in)
| Add another implicit function to the list of functions, weighting it by a factor of 1. More...
void | RemoveAllFunctions ()
| Remove all functions from the list. More...
void | SetFunctionWeight (vtkImplicitFunction *f, double weight)
| Set the weight (coefficient) of the given function to be weight. More...
virtual void | SetNormalizeByWeight (vtkTypeBool)
| When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions. More...
virtual vtkTypeBool | GetNormalizeByWeight ()
virtual void | NormalizeByWeightOn ()
virtual void | NormalizeByWeightOff ()
virtual double | EvaluateFunction (double x[3])=0
| Evaluate implicit function using current functions and weights. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate implicit function using current functions and weights. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate implicit function using current functions and weights. More...
Public Member Functions inherited from vtkImplicitFunction
vtkImplicitFunction * | NewInstance () const
virtual void | FunctionValue (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (const double x[3])
double | FunctionValue (double x, double y, double z)
void | FunctionGradient (const double x[3], double g[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (const double x[3])
double * | FunctionGradient (double x, double y, double z)
virtual void | SetTransform (vtkAbstractTransform *)
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | SetTransform (const double elements[16])
virtual vtkAbstractTransform * | GetTransform ()
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
virtual double | EvaluateFunction (double x, double y, double z)
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkImplicitSum * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitSum * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImplicitFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkImplicitSum ()
| ~vtkImplicitSum () override
void | CalculateTotalWeight (void)
Protected Member Functions inherited from vtkImplicitFunction
| vtkImplicitFunction ()
| ~vtkImplicitFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkImplicitFunctionCollection * | FunctionList
vtkDoubleArray * | Weights
double | TotalWeight
vtkTypeBool | NormalizeByWeight
Protected Attributes inherited from vtkImplicitFunction
vtkAbstractTransform * | Transform
double | ReturnValue [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

implicit sum of other implicit functions

vtkImplicitSum produces a linear combination of other implicit functions. The contribution of each function is weighted by a scalar coefficient. The NormalizeByWeight option normalizes the output so that the scalar weights add up to 1. Note that this function gives accurate sums and gradients only if the input functions are linear.

Definition at line 35 of file vtkImplicitSum.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImplicitFunction vtkImplicitSum::Superclass

Definition at line 40 of file vtkImplicitSum.h.

## Constructor & Destructor Documentation

## ◆ vtkImplicitSum()

vtkImplicitSum::vtkImplicitSum | ( |  | ) |
| protected

## ◆ ~vtkImplicitSum()

vtkImplicitSum::~vtkImplicitSum | ( |  | ) |
| override protected

## Member Function Documentation

## ◆ New()

static vtkImplicitSum* vtkImplicitSum::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkImplicitSum::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkImplicitSum::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImplicitFunction.

## ◆ SafeDownCast()

static vtkImplicitSum* vtkImplicitSum::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImplicitSum::NewInstanceInternal | ( |  | ) | const
| protected virtual

Reimplemented from vtkImplicitFunction.

## ◆ NewInstance()

vtkImplicitSum* vtkImplicitSum::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkImplicitSum::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkImplicitFunction.

## ◆ EvaluateFunction() [1/4]

double vtkImplicitSum::EvaluateFunction | ( | double | x[3] | ) |
| override virtual

Evaluate function at position x-y-z and return value.

You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class.

Implements vtkImplicitFunction.

## ◆ EvaluateGradient()

void vtkImplicitSum::EvaluateGradient | ( | double | x[3],
|  | double | g[3]
| ) |  |
| override virtual

Evaluate gradient of the weighted sum of functions.

Input functions should be linear.

Implements vtkImplicitFunction.

## ◆ GetMTime()

vtkMTimeType vtkImplicitSum::GetMTime | ( |  | ) |
| override virtual

Override modified time retrieval because of object dependencies.

Reimplemented from vtkImplicitFunction.

## ◆ AddFunction() [1/2]

void vtkImplicitSum::AddFunction | ( | vtkImplicitFunction * | in,
|  | double | weight
| ) |  |

Add another implicit function to the list of functions, along with a weighting factor.

## ◆ AddFunction() [2/2]

void vtkImplicitSum::AddFunction | ( | vtkImplicitFunction * | in | ) |
| inline

Add another implicit function to the list of functions, weighting it by a factor of 1.

Definition at line 72 of file vtkImplicitSum.h.

## ◆ RemoveAllFunctions()

void vtkImplicitSum::RemoveAllFunctions | ( |  | ) |

Remove all functions from the list.

## ◆ SetFunctionWeight()

void vtkImplicitSum::SetFunctionWeight | ( | vtkImplicitFunction * | f,
|  | double | weight
| ) |  |

Set the weight (coefficient) of the given function to be weight.

## ◆ SetNormalizeByWeight()

virtual void vtkImplicitSum::SetNormalizeByWeight | ( | vtkTypeBool |  | ) |
| virtual

When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions.

This process does not otherwise normalize the gradient vector. By default, NormalizeByWeight is off.

## ◆ GetNormalizeByWeight()

virtual vtkTypeBool vtkImplicitSum::GetNormalizeByWeight | ( |  | ) |
| virtual

## ◆ NormalizeByWeightOn()

virtual void vtkImplicitSum::NormalizeByWeightOn | ( |  | ) |
| virtual

## ◆ NormalizeByWeightOff()

virtual void vtkImplicitSum::NormalizeByWeightOff | ( |  | ) |
| virtual

## ◆ CalculateTotalWeight()

void vtkImplicitSum::CalculateTotalWeight | ( | void |  | ) |
| protected

## ◆ EvaluateFunction() [2/4]

virtual double vtkImplicitFunction::EvaluateFunction

Evaluate implicit function using current functions and weights.

## ◆ EvaluateFunction() [3/4]

virtual void vtkImplicitFunction::EvaluateFunction

Evaluate implicit function using current functions and weights.

## ◆ EvaluateFunction() [4/4]

virtual double vtkImplicitFunction::EvaluateFunction
| inline

Evaluate implicit function using current functions and weights.

Definition at line 123 of file vtkImplicitFunction.h.

## Member Data Documentation

## ◆ FunctionList

vtkImplicitFunctionCollection* vtkImplicitSum::FunctionList
| protected

Definition at line 101 of file vtkImplicitSum.h.

## ◆ Weights

vtkDoubleArray* vtkImplicitSum::Weights
| protected

Definition at line 102 of file vtkImplicitSum.h.

## ◆ TotalWeight

double vtkImplicitSum::TotalWeight
| protected

Definition at line 103 of file vtkImplicitSum.h.

## ◆ NormalizeByWeight

vtkTypeBool vtkImplicitSum::NormalizeByWeight
| protected

Definition at line 106 of file vtkImplicitSum.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkImplicitSum.h